// ---------------------------------------------------------------------------
// - Predwww.hpp                                                             -
// - afnix:www module - predicates declaration                               -
// ---------------------------------------------------------------------------
// - This program is free software;  you can redistribute it  and/or  modify -
// - it provided that this copyright notice is kept intact.                  -
// -                                                                         -
// - This program  is  distributed in  the hope  that it will be useful, but -
// - without  any  warranty;  without  even   the   implied    warranty   of -
// - merchantability or fitness for a particular purpose.  In no event shall -
// - the copyright holder be liable for any  direct, indirect, incidental or -
// - special damages arising in any way out of the use of this software.     -
// ---------------------------------------------------------------------------
// - copyright (c) 1999-2006 amaury darsch                                   -
// ---------------------------------------------------------------------------

#ifndef  AFNIX_PREDWWW_HPP
#define  AFNIX_PREDWWW_HPP

#ifndef  AFNIX_OBJECT_HPP
#include "Object.hpp"
#endif
 
namespace afnix {

  /// this file contains the predicates associated with the afnix:txt
  /// standard module.
  /// @author amaury darsch

  /// the url object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_urlp (Runnable* robj, Nameset* nset, Cons* args);

  /// the cookie object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_cokp (Runnable* robj, Nameset* nset, Cons* args);

  /// the cgi query object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_cgip (Runnable* robj, Nameset* nset, Cons* args);

  /// the tag element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_tagp (Runnable* robj, Nameset* nset, Cons* args);

  /// the element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_elmp (Runnable* robj, Nameset* nset, Cons* args);

  /// the div element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_divp (Runnable* robj, Nameset* nset, Cons* args);

  /// the html ref object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_refp (Runnable* robj, Nameset* nset, Cons* args);

  /// the td element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_tbdp (Runnable* robj, Nameset* nset, Cons* args);

  /// the th element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_tbhp (Runnable* robj, Nameset* nset, Cons* args);

  /// the tr element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_tbrp (Runnable* robj, Nameset* nset, Cons* args);

  /// the table element object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_tblp (Runnable* robj, Nameset* nset, Cons* args);

  /// the html page object predicate
  /// @param robj the current runnable
  /// @param nset the current nameset
  /// @param args the arguments list
  Object* www_htmp (Runnable* robj, Nameset* nset, Cons* args);
}

#endif
